package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLConstraintList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLConstraintList extends JNIObject  {
	
	/* @generated */
	protected ISLConstraintList(long ptr) {
		/*** PROTECTED REGION ID(ISLConstraintList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLConstraintList build(long ptr) {
		return new ISLConstraintList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLConstraintList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_constraint_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLConstraintList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_constraint_list_alloc) DISABLED START ***/
		ISLConstraintList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLConstraintList.build(ISLNative.isl_constraint_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLConstraintList constraintlist, int format) { 
		/*** PROTECTED REGION ID(static_isl_constraint_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_list_to_string(getNativePtr(constraintlist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_constraint_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_constraint_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_constraint_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_copy 
	 * 
	 * @generated
	**/
	public ISLConstraintList copy() {
		/*** PROTECTED REGION ID(isl_constraint_list_copy) DISABLED START ***/
		ISLConstraintList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLConstraintList.build(ISLNative.isl_constraint_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_constraint_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_constraint_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_n_constraint 
	 * 
	 * @generated
	**/
	public int getNbConstraints() {
		/*** PROTECTED REGION ID(isl_constraint_list_n_constraint) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_list_n_constraint(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_get_constraint 
	 * 
	 * @generated
	**/
	public ISLConstraint get(int index) {
		/*** PROTECTED REGION ID(isl_constraint_list_get_constraint) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLConstraint.build(ISLNative.isl_constraint_list_get_constraint(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_set_constraint 
	 * 
	 * @take this constraint
	 * @generated
	**/
	public ISLConstraintList set(int index, ISLConstraint constraint) {
		/*** PROTECTED REGION ID(isl_constraint_list_set_constraint) DISABLED START ***/
		ISLConstraintList res;
		
		synchronized(LOCK) {
			checkParameters(this, constraint);
			try {
				res = ISLConstraintList.build(ISLNative.isl_constraint_list_set_constraint(getNativePtr(this), index, getNativePtr(constraint)));
			} finally {
				taken(this);
				taken(constraint);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLConstraintList insert(int pos, ISLConstraint el) {
		/*** PROTECTED REGION ID(isl_constraint_list_insert) DISABLED START ***/
		ISLConstraintList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLConstraintList.build(ISLNative.isl_constraint_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLConstraintList add(ISLConstraint el) {
		/*** PROTECTED REGION ID(isl_constraint_list_add) DISABLED START ***/
		ISLConstraintList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLConstraintList.build(ISLNative.isl_constraint_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLConstraintList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_constraint_list_drop) DISABLED START ***/
		ISLConstraintList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLConstraintList.build(ISLNative.isl_constraint_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLConstraintList concat(ISLConstraintList list2) {
		/*** PROTECTED REGION ID(isl_constraint_list_concat) DISABLED START ***/
		ISLConstraintList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLConstraintList.build(ISLNative.isl_constraint_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLConstraintList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
